/*여러개의 LED */
// 배열에 대해서 알아 보자

int ledPins[] = {2,3,4,5,6,7,8,9};
char example[] = {'a','r','d','u','i','n','o'}; //쓰지 않지만 배열을 이해 하기 위해 만듬
float example2[] = {3.14159265, 2.71828182846, 6.62606957 }; //쓰지 않지만 배열을 이해 하기 위해 만듬

void setup()
{
  int index; //페이지수로 이해하자
 
  for(index = 0; index <= 7; index++)
  {
    pinMode(ledPins[index],OUTPUT);
    //  ledPins[0]은 2 , 마찬가지로 example[1]은 'r'
  }
}


void loop()
{
  oneAfterAnotherLoop();  // 배열을 이용하여 LED를 순서대로 켜고 끄기
  oneOnAtATime();         // 한번에 하나씩 LED를 켜고 끄기
  pingPong();             // 탁구공처럼 왔다갔다
  marquee();              // LED 2개가 동시에 움직임
  randomLED();            // Blink LEDs randomly
}
 
void oneAfterAnotherLoop()
{
  int index;
  const int delayTime = 100; // 지연시간 0.1초
  
  for(index = 0; index <= 7; index++)
  {
    digitalWrite(ledPins[index], HIGH);
    delay(delayTime);                
  }                                  
 
  for(index = 7; index >= 0; index--)
  {
    digitalWrite(ledPins[index], LOW);
    delay(delayTime);
  }               
}


// oneOnAtATime() 한번에 하나씩 켜기
void oneOnAtATime()
{
  int index;
  int delayTime = 100; // 지연시간 0.1초
 
  for(index = 0; index <= 7; index++)
  {
    digitalWrite(ledPins[index], HIGH);  // LED 켜고
    delay(delayTime);                    // 잠시 기다리다
    digitalWrite(ledPins[index], LOW);   // LED 끈다
  }
}

 
// pingPong()  탁구공처럼 왔다갔다


void pingPong()
{
  int index;
  int delayTime = 100;   

  oneOnAtATime(); // 한번에 하나씩 켜기

  // 7에서 거꾸로 가기,   
  for(index = 7; index >= 0; index--) //index-- 는 index=index-1 을 줄여쓴 것임
  {
    digitalWrite(ledPins[index], HIGH);  // turn LED on
    delay(delayTime);                    // pause to slow down
    digitalWrite(ledPins[index], LOW);   // turn LED off
  }
}


//marquee() LED 2개가 동시에 움직임
void marquee()
{
  int index;
  int delayTime = 200; // milliseconds to pause between LEDs
                       // Make this smaller for faster switching
  
  // Step through the first four LEDs
  // (We'll light up one in the lower 4 and one in the upper 4)
  
  for(index = 0; index <= 3; index++) // Step from 0 to 3
  {
    digitalWrite(ledPins[index], HIGH);    // Turn a LED on
    digitalWrite(ledPins[index+4], HIGH);  // Skip four, and turn that LED on
    delay(delayTime);                      // Pause to slow down the sequence
    digitalWrite(ledPins[index], LOW);     // Turn the LED off
    digitalWrite(ledPins[index+4], LOW);   // Skip four, and turn that LED off
  }
}



void randomLED() //8개중 아무거나 맘대로 켜지고 꺼지기
{
  int index;
  int delayTime;
   
  index = random(8);	// 0~7사이의 8가지 숫자가 임의로 생성된다.
  delayTime = 100;
	
  digitalWrite(ledPins[index], HIGH);  // turn LED on
  delay(delayTime);                    // 잠시 기다려
  digitalWrite(ledPins[index], LOW);   // turn LED off
}

