/* RGB LED 무지개색 */
//const 값이 바뀌지 않도록 변수를 지정한다.
const int RED_PIN = 9;
const int GREEN_PIN = 10;
const int BLUE_PIN = 11;

int DISPLAY_TIME = 100;  // In milliseconds


void setup()
{
  // Here we'll configure the Arduino pins we're using to
  // drive the LED to be outputs:

  pinMode(RED_PIN, OUTPUT);
  pinMode(GREEN_PIN, OUTPUT);
  pinMode(BLUE_PIN, OUTPUT);
  Serial.begin(9600);
}


void loop()
{
  
// 빨강, 녹색, 파랑색을 켜고 끄는 것으 조합을 보여준다.
  mainColors();
// 색이 점진적으로 변화하게 한다.
  showSpectrum();
}


void mainColors() // 빨강, 녹색, 파랑색의 On, Off조합 8가지를 표현
{
  for(int i = 0 ; i < 8; i++){
    if( i & 1  ){ // i와 001의 비트 연산
      Serial.print("R");
      digitalWrite(RED_PIN, HIGH );
    }else{
      digitalWrite(RED_PIN, LOW);
      Serial.print("r");
    }    
    //digitalWrite(RED_PIN, (i & 1) ? HIGH:LOW); //와 같이 줄여 쓸 수 있다.

    digitalWrite(GREEN_PIN, (i & 2) ? HIGH:LOW); //i와  100의 비트 연산    
    
    digitalWrite(BLUE_PIN, i & 4); //i와  100의 비트 연산 
    //digitalWrite는 0보다 크면 HIGH로 인식한다.
    delay(1000);
  }
}




void showSpectrum()
{
  int intensity;  // "intensity"라는 이름의 변수 생성
  for (intensity = 0; intensity < 256; intensity++)
  {
     analogWrite(RED_PIN, intensity );
     analogWrite(GREEN_PIN, decrease(intensity));
     analogWrite(BLUE_PIN, 0 );
     delay(10);   // Delay for 10 ms (1/100th of a second)
  }
  for (intensity = 0; intensity < 256; intensity++)
  {
     analogWrite(RED_PIN, decrease(intensity) );
     analogWrite(GREEN_PIN, 0);
     analogWrite(BLUE_PIN, intensity );
     delay(10);   // Delay for 10 ms (1/100th of a second)
  }
  for (intensity = 0; intensity < 256; intensity++)
  {
     analogWrite(RED_PIN, 0 );
     analogWrite(GREEN_PIN, intensity);
     analogWrite(BLUE_PIN, decrease(intensity) );
     delay(10);   // Delay for 10 ms (1/100th of a second)
  }
}

int decrease(int intensity){
  return(255 - intensity);
}
