/* Example sketch 09 FLEX SENSOR */

#include <Servo.h> 


Servo servo1;

// 아날로그 0번에 플렉스 센서와 저항 사이 선을 연결함

const int flexpin = 0; 


void setup() 
{ 
  // 무슨일이 진행중인지 확인 할 수 있게 시리얼 모니터 준비   
  Serial.begin(9600);  
  
  servo1.attach(9); // 서보모터는 9번 핀에 연결
} 


void loop() 
{ 
  int flexposition;    // Input value from the analog pin.
  int servoposition;   // Output value to the servo.

  // Read the position of the flex sensor (0 to 1023):
  
  flexposition = analogRead(flexpin);

  // 플렉스 센서의 출력은 보통 600-900 사이임 
  // 0~180으로 맵핑 
  servoposition = map(flexposition, 600, 900, 0, 180);
  servoposition = constrain(servoposition, 0, 180);
  // 센서에서 읽을 갑으로 서보를 이동한다.
  servo1.write(servoposition);

  // 시리얼 모니터로 실제로 센싱되는 값을 출력해서 
  // 값이 적절하게 나오는지 확인 할 수 있게 하자
  
  Serial.print("sensor: ");
  Serial.print(flexposition);
  Serial.print("  servo: ");
  Serial.println(servoposition);
  
  delay(20);  // 모터가 실제로 움직일 수 있게 0.02초 기다린다. 
} 


